#!/usr/bin/env python3
# -*- coding: utf-8 -*-

import os
import sys
import base64
from zephir.lib_zephir import flushed_input


def display_help():
    print("Sauvegarde une cle ssh d'un utilisateur dans Zephir")
    print("{} [utilisateur] [--key chemin_de_la_clé]".format(sys.argv[0]))


def argparser():
    arglen = len(sys.argv)
    if arglen == 1:
        return None, None
    if sys.argv[1] in ['-h', '--help']:
        display_help()
        sys.exit(0)

    user = sys.argv[1]

    if sys.argv[2] in ['-k', '--key']:
        keypath = sys.argv[3]
        return user, keypath

    return user, None


def main():
    user, keypath = argparser()

    if user is None :
        user = flushed_input("Utilisateur : ")

    if keypath is None :
        keypath = flushed_input("Chemin de la clé ssh : ")
    try:
        keyssh = None
        with open(keypath, 'rb') as f:
            keyssh = f.read()

        clef_ssh = base64.encodebytes(keyssh).decode()
        os.chdir("/etc/postgresql/")
        cmd="""sudo -u postgres psql -c "update users set cle='{}' where login='{}';" zephir""".format(clef_ssh,user)
        output = os.popen(cmd)
        res = output.read().strip()
        output.close()
        if res == "UPDATE 1":
            print("Clé ssh mis à jour pour l'utilisateur : {}" .format(user))
            print("Executer le script authorize_user_group pour authoriser l'accès de l'utilisateur aux serveurs")
        else:
            print("Erreur : ", str(res))
    except IOError:
        print("Fichier ou dossier introuvable : {}".format(keypath))


if __name__ == '__main__':
    main()
